<script lang="ts">
  import registrationBg from '$lib/assets/images/home/collaborative.png';
  import User from '$lib/components/ui-elements/User.svelte';
  import Badge from '$lib/components/ui-elements/Badge.svelte';
  import TeamTable from '$lib/components/pages/team-dashboard/TeamTable.svelte';
  import type { EventGroupTeam } from '$lib/graphql/types';
  import { createEventDispatcher } from 'svelte';
  import { formatToLocalTime } from '$lib/util/timeHelpers';
  import { hasApiRole } from '$lib/components/layout/data/nav-tabs';
  import { authTokenParsed } from '$stores/authStore';
  import { Tooltip } from 'flowbite-svelte';
  import Fa from 'svelte-fa';
  import { faFingerprint } from '@fortawesome/free-solid-svg-icons';

  export let team: EventGroupTeam;
  export let hideControls = false;
  export let background = registrationBg;
  const dispatch = createEventDispatcher();
</script>

<div class="lg:flex">
  {#if background}
    <div
      class="h-48 lg:h-auto lg:w-48 flex-none bg-cover rounded-t lg:rounded-t-none lg:rounded-l text-center overflow-hidden"
      style="background-image: url({background})" />
  {/if}
  <div
    class="border border-gray-400 rounded-b lg:border-t lg:border-gray-400 lg:rounded-b-none lg:rounded-r
           bg-white p-4 flex flex-col justify-between leading-normal grow">
    <div class="text-gray-900 font-bold text-xl mb-1">
      {#if hasApiRole($authTokenParsed, 'staff')}
        <span id="copy-{team.id}" class="inline-block cursor-pointer" on:click={() => navigator.clipboard.writeText(team.id)}>
          <Fa icon={faFingerprint}></Fa>
        </span>
        <Tooltip class="px-2" triggeredBy="#copy-{team.id}">Copy Team ID</Tooltip>
      {/if}
      {team.long_name || team.name}
    </div>
    <div class="flex flex-row flex-wrap mb-1 -ml-1">
      {#each team.institution?.regions as entry}
        <Badge class="m-1" color="yellow">{entry.region.name.replace('_', ' ')}</Badge>
      {/each}
      <Badge class="m-1" color="green">{team.institution?.name}</Badge>
    </div>
    <div class="text-gray-900 font-bold text-sm mb-2">Created on: {formatToLocalTime(team.created)}</div>

    <div>
      {#if team.team_full}
        <span class="font-bold" style="color: red;">Team Full ({team.team_size})</span>
      {:else}
        <span class="font-bold">Size: </span>{team.team_size}
      {/if}
    </div>

    <div>
      <span class="font-bold">Captain:</span>
      <div class="grid grid-cols-2">
        {#if team.team_lead_id}
          <User user={{ user_id: team.team_lead_id }} />
        {:else}
          N/A
        {/if}
      </div>
    </div>

    <div>
      <span class="font-bold mr-2">Liaison:</span>
      <div class="grid grid-cols-2">
        {#if team.liaison_id}
          <User user={{ user_id: team.liaison_id }} />
        {:else}
          N/A
        {/if}
      </div>
    </div>

    {#if team.events?.length}
      <div>
        <span class="font-bold">Events:</span>
        {#each team.events as event}
          <div class="pl-2 -ml-2 hover:bg-cyber-gray-200">
            {event.event.name}
            {#if event.event.event_group}
              - {event.event.event_group.name}
            {/if}
            ({formatToLocalTime(event.created)})
          </div>
        {:else}
          N/A
        {/each}
      </div>
    {/if}

    <hr class="h-px my-5 bg-gray-200 border-0 dark:bg-gray-700" />
    <TeamTable on:delete={() => dispatch('refetch')} on:refetch={() => dispatch('refetch')} {team} {hideControls} />
  </div>
</div>
